//package src;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

class AttributesHandler {

    //Reading attributes and data
    public List<String> attributeNames;
    public String decisionAttribute;
    public String decisionFrom;
    public String decisionTo;
    public List<String> stableAttributes;
    public List<String> flexibleAttributes;
    public String outputData;
    public Map<String, HashSet<String>> decisionValues;

    private Map<String, HashSet<String>> distinctAttributeValues;
    private Map<HashSet<String>, HashSet<String>> attributeValues;

    // default constructor
    public AttributesHandler() {
        this.attributeNames = new ArrayList<String>();
        this.stableAttributes = new ArrayList<String>();
        this.flexibleAttributes = new ArrayList<String>();
        this.outputData = "";
        this.decisionValues = new HashMap<String, HashSet<String>>();

        this.distinctAttributeValues = new HashMap<String, HashSet<String>>();
        this.attributeValues = new HashMap<HashSet<String>, HashSet<String>>();
    }

    public void setAttributeValues(
        HashMap<HashSet<String>, HashSet<String>> attributeValues
    ) {
        this.attributeValues = attributeValues;
    }

    public void setDistinctAttributeValues(
        HashMap<String, HashSet<String>> distinctAttributeValues
    ) {
        this.distinctAttributeValues = distinctAttributeValues;
    }

    public List<String> readAttributes(String filename) {
        System.out.println("Reading attributes and data");
        try {
            Scanner input = new Scanner(new File(filename));

            while (input.hasNext()) {
                this.attributeNames.add(input.next());
            }

        } catch (FileNotFoundException e) {
            System.out.println("File Not Found");
            e.printStackTrace();
        }

        return this.attributeNames;
    }

    public void setDecisionAttribute(
        String decision,
        String decisionTo,
        String decisionFrom
    ) {
        System.out.println("\nAttributes Available");
        System.out.println("--------------------------");

        this.storeData(decision);
        this.decisionAttribute = decision;

        HashSet<String> decisionValues = 
            this.distinctAttributeValues.get(decision);
        System.out.println("From this list, please select a decision to and decision from: " + this.distinctAttributeValues.get(this.decisionAttribute));
        
        System.out.println("Decision To: " + decisionTo);
        this.decisionTo = decisionTo;
        System.out.println("Decision From: " + decisionFrom);
        this.decisionFrom = decisionFrom;

        this.removeDecisionValueFromAttributes(decisionValues);
        
    }

    private void removeDecisionValueFromAttributes(
        HashSet<String> decisionValues
    ) {
        for (String value : decisionValues) {
            HashSet<String> newHash = new HashSet<String>();
            newHash.add(value);
            this.decisionValues.put(value, this.attributeValues.get(newHash));
            this.attributeValues.remove(newHash);
        }
    }

    public void storeData(String content) {
        this.outputData += content + "\n";
    }

}
