//package src;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

class GUI extends JFrame implements ActionListener , ItemListener {
    JFileChooser fileChooser = new JFileChooser();
    static JFrame frame ;
    static JTextField dataFile, 
                      attributesFile, 
                      decision, 
                      decisionTo, 
                      decisionFrom, 
                      stableAttributes,
                      minSupport,
                      minConfidence;
    JButton data,attribute,submit,applyDecisionSelection;
    static List<String> all_attributes = new ArrayList<String>();
    static JComboBox comboBox;
    static JLabel  l1, attributeNames, decisionNames;
    String decisionAttributeTo = "";
    String getDecisionAttributeFrom = "";


    public GUI() {
        // Initializing all fields
        frame = new JFrame();
        frame.setTitle("My JFrame Title");
        l1 = new JLabel("Action Rules Extraction");
        attributeNames = new JLabel();
        decisionNames = new JLabel();
        dataFile = new JTextField("Please select Data file",20);
        data = new JButton("Search");
        applyDecisionSelection = new JButton("Apply");
        attributesFile = new JTextField("Please select Attribute file",20);
        attribute = new JButton("Search");
        stableAttributes = new JTextField("Selected Stable Attributes (comma seperated)",20);
        decision = new JTextField("Selected Decision Attribute",20);
        decisionTo= new JTextField("Enter Decision Attribute To Value",20);
        decisionFrom= new JTextField("Enter Decision Attribute From Value",20);
        minSupport= new JTextField("Enter Minimum Support", 20);
        minConfidence= new JTextField("Enter Minimum Confidence", 20);
        submit = new JButton("Submit");
        // adding all components to the frame
        add(dataFile);
        add(data);
        add(attributesFile);
        add(attribute);
        add(attributeNames);
        add(stableAttributes);
        add(decision);
        add(applyDecisionSelection);
        add(decisionNames);
        add(decisionTo);
        add(decisionFrom);
        add(minSupport);
        add(minConfidence);
        add(submit);

        // file selector for data.txt
        data.addActionListener(ev -> {
            int returnVal = fileChooser.showOpenDialog(frame);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                File file = fileChooser.getSelectedFile();
                try {
                    BufferedReader input = new BufferedReader(new InputStreamReader(
                            new FileInputStream(file)));
                    dataFile.setText(file.getPath());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else {
                System.out.println("Operation is CANCELLED :(");
            }
        });

        // file selector for attribute.txt
        attribute.addActionListener(ev -> {
            int returnVal = fileChooser.showOpenDialog(frame);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                File file = fileChooser.getSelectedFile();
                try {
                    AttributesHandler attributesHandler = new AttributesHandler();
                    attributesFile.setText(file.getPath());
                    List<String> attributeNamesList = attributesHandler.readAttributes(file.getPath());
                    attributeNames.setText("Attributes: " + String.join(",",attributeNamesList));
                    
                } catch (Exception e) {
                    e.printStackTrace();
                }
            } else {
                System.out.println("Operation is CANCELLED :(");
            }
        });

        applyDecisionSelection.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                try {
                    AttributesHandler attributesHandler = new AttributesHandler();
                    List<String> attributeNames = attributesHandler.readAttributes(attributesFile.getText());
                    //Read data
                    IOHandler ioHandler = new IOHandler(attributeNames);
                    ioHandler.readData(dataFile.getText());
                    String decisionValues = String.join("," , ioHandler.distinctAttributeValues.get(decision.getText()));
                    attributesHandler.setAttributeValues(ioHandler.attributeValues);
                    attributesHandler.setDistinctAttributeValues(ioHandler.distinctAttributeValues);
                    decisionNames.setText("Decision Values: " + decisionValues);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
        // Submit

        submit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                try {
                    Main.run(
                        dataFile.getText(), // data file
                        attributesFile.getText(), // attributefile
                        stableAttributes.getText(),
                        decision.getText(), // decision
                        decisionTo.getText(), // to
                        decisionFrom.getText(), // from
                        minSupport.getText(),
                        minConfidence.getText()
                    );
                    dispose();
                    setVisible(false);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });



        //setDropDown(frame);
       // (FlowLayout.LEFT, 20, 10);

        setLayout(new FlowLayout());
        setVisible(true);
        setSize(350,500);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setTitle("Action Rules Extraction");
        getContentPane().setBackground(Color.GRAY);

        getRootPane().setBorder(
                BorderFactory.createMatteBorder(7, 7, 7, 7, Color.BLACK));

    }

    @Override
    public void actionPerformed(ActionEvent e) {

    }


    public void itemStateChanged(ItemEvent e)
    {
        // if the state combobox is changed
        if (e.getSource() == comboBox) {

            l1.setText(comboBox.getSelectedItem() + " selected");
        }
    }



}