//package src;

import java.util.ArrayList;

public class LERSHandler {
    private ArrayList<ArrayList<String>> data;

    public LERSHandler(ArrayList<ArrayList<String>> data) {
        this.data = data;
    }

    public int calculateSupportLERS(ArrayList<String> key, String value) {
        ArrayList<String> tempList = new ArrayList<String>();

        for (String val : key) {
            tempList.add(val);
        }

        if (!value.isEmpty())
            tempList.add(value);

        return this.findLERSSupport(tempList);
    }

    private int findLERSSupport(ArrayList<String> tempList) {
        int count = 0;

        for (ArrayList<String> data : data) {
            if (data.containsAll(tempList))
                count++;
        }

        return count;
    }

    public String calculateConfidenceLERS(
        ArrayList<String> key, 
        String value
    ) {
        int num = this.calculateSupportLERS(key, value);
        int den = this.calculateSupportLERS(key, "");
        double confidence = 0.0;

        if (den != 0)
            confidence = (num * 100) / den;

        return String.valueOf(confidence);
    }
}
